#!/usr/bin/perl
#
# Parse grid search output files perf.txt, igam, ic, to find best parameters (c,gamma)
#
# Written by Paul Burns
#

my @log_gamma = (-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1);
#my @log_c = (-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);

open($in,"<perf.txt");

$ct = 0;
$best = -10000;
$ibest = 0;

while ($line = <$in>)
{
	chomp;
	++$ct;
	$nt = int($line);
	
	$line = <$in>;
	chomp;
	$nf = int($line);

	$d = $nt - $nf;
	
	if ($d > $best && $nt!=0) {
		$best = $nt-$nf;
		$ibest = $ct;
	}
}

print "best params found at result $ibest with $best Tp-Fp\n";

open($in,"<igam");
$ct = 0;

while ($line = <$in>)
{
	chomp;
	++$ct;
	
	$line = <$in>;
	chomp;
	$igam = int($line);
	
	if ($ct == $ibest) {
		last;
	}
}

print "igam = $igam\n";

open($in,"<ic");
$ct = 0;

while ($line = <$in>)
{
	chomp;
	++$ct;
	
	$line = <$in>;
	chomp;
	$ic = int($line);
	
	if ($ct == $ibest) {
		last;
	}
}

print "ic = $ic\n";

close($in);

$gamma = exp( $log_gamma[$igam] );
$log_c = $log_gamma[$igam] + 9 - 2*$igam + $ic;
$c = exp( $log_c );

#$c = exp( $log_c[$ic] );

print "(c,gamma) = ($c,$gamma)\n";

open(CG,">cg");
print CG "$c\n$gamma\n";
close(CG);
