#!/usr/bin/perl
#
#
#
#
#SJS reMap.sam Gap.sam
use List::Util qw(first max maxstr min minstr reduce shuffle sum);

open($in,"<",shift@ARGV);#junc// SJS

while(<$in>){
	chomp;
	my @m = split(/\t/);
	$cano{$m[0]}{$m[1]}{$m[2]} = $m[3];
}
#$G = shift@ARGV;
#$S = shift@ARGV;
$pair = shift@ARGV||1;  # 1
#if($pair == 1){system("cat $G $S | sort -t '/' -k 1,1 > newtemp");}
#else{system("cat $G $S | sort -k 1,1 > newtemp");}

open($in,"<",shift@ARGV);#REF MAY 25   ref DNA sequence
while(<$in>){
	chomp;
	if(substr($_,0,1) eq ">"){
		@c = split(/\s+/,$_); #in case of blank in chr line;
		$chr = substr($c[0],1);
		next;
	}
	$REF{$chr} .= $_;
}
open(OO,">head");
foreach my $chr (keys %REF){
	print OO '@SQ',"\t","SN:$chr\tLN:",length($REF{$chr}),"\n";
}

#open($in,"<newtemp");
$name_temp = "";
$ct = 0;
while(<STDIN>){
	chomp;
	$line = $_;
	my @m = split(/\t/);
	if($name_temp ne $m[0]){
		$temp1 = $m[0];
		action();
		%hash=();

		$name_temp = $temp1;
	}
	my @m = split(/\t/,$line);
	if($m[$#m] eq "tag"){
		#print "doing remap ", $m[$#m], "\n";
		if ( !(exists $hash{$m[0]}) ) {
			do_remap();
		}
	}
	else{
		#print "doing gap ", $m[$#m], "\n";
		do_gap();
	}
	++$ct;
	
	#if ($ct > 100) {
	#	last;
	#}
}
action();





sub do_gap{
	my @m = split(/\t/,$line);
	$key = join(":",$m[2],$m[3],$m[5]);  # chr:pos:cigar
	@k = split(/M|N/,$m[5]);
	$hash{$m[0]}{$key}[0] = $k[1];   # length
	$hash{$m[0]}{$key}[1] = $m[9];   # seq
	$hash{$m[0]}{$key}[2] = $m[10];  # qua
	$hash{$m[0]}{$key}[3] = $m[6];   # cano flag
	$hash{$m[0]}{$key}[4] = $m[1];   # ori
	$hash{$m[0]}{$key}[5] = $m[7];   # mismatches	
	$hash{$m[0]}{$key}[6] = "$m[$#m-3]\t$m[$#m-2]\t$m[$#m-1]\t$m[$#m]";   # pos=xxx string	

	#print "do_gap, $hash{$m[0]}{$key}[6]\n";
}


sub do_remap{
	my @m = split(/\t/, $line);
	$key = join(":",$m[2],$m[3],$m[5]);  # chr:pos:cigar
	@k = split(/M|N/,$m[5]);
	$hash{$m[0]}{$key}[0] = $k[1];  # length
	$hash{$m[0]}{$key}[1] = $m[9];  # seq
	$hash{$m[0]}{$key}[2] = $m[10]; # qua
	$hash{$m[0]}{$key}[3] = $m[6];  # cano flag
	$hash{$m[0]}{$key}[4] = $m[1];  # ori
	$hash{$m[0]}{$key}[5] = $m[7];  # mismatches
	$hash{$m[0]}{$key}[6] = $m[$#m];   # tag	
	
	#print "do_remap, $hash{$m[0]}{$key}[6]\n";
}

sub action{
	foreach $name (keys %hash){
		#print $name,"\n";
#		print scalar keys %{$hash{$name}},"\n";
		if(scalar keys %{$hash{$name}} > 1){
			$flag1 = 0;
			$flag2 = 0;
			$flag0 = 0;
			foreach $key (keys %{$hash{$name}}){
				if($hash{$name}{$key}[3] == 1){		# cano
					$flag1 = 1;
				}
				if($hash{$name}{$key}[3] >= 2){
					$flag2 = 1;
				}
				if($hash{$name}{$key}[3] == 0){
					$flag0 = 1;
				}

			}
#			print $flag0,"\t",$flag1,"\t",$flag2,"\n";
			if( ($flag1 == 1 && ($flag2 == 1 || $flag0 == 1))){
				foreach $key (keys %{$hash{$name}}){
					if($hash{$name}{$key}[3] == 0 || $hash{$name}{$key}[3] >= 2){
						delete $hash{$name}{$key};
					}
				}
			}
			if($flag2 == 1 && $flag0 == 1 && $flag1 == 0){
				foreach $key (keys %{$hash{$name}}){
					if($hash{$name}{$key}[3] == 0){
						delete $hash{$name}{$key};
					}
				}
			}
#			print scalar keys %{$hash{$name}},"\n";
			if(scalar keys %{$hash{$name}} != 1){
				## just keep the alignment with the shortest gap
				@rank = sort {$hash{$name}{$b}[0] <=> $hash{$name}{$a}[0]} keys %{$hash{$name}};
				for($i = 1; $i < scalar @rank; $i++){#                 @{$final{$name}{$rank[$i]}} = @{$hash{$name}{$rank[$i]}}
					delete $hash{$name}{$rank[$i]};
				}
			}
		}

		foreach $key (keys %{$hash{$name}})
		{
			@t = split(/:/,$key);
	## $hash{$m[0]}{$key}[0] = $k[1];  # length
	## $hash{$m[0]}{$key}[1] = $m[9];  # seq
	## $hash{$m[0]}{$key}[2] = $m[10]; # qua
	## $hash{$m[0]}{$key}[3] = $m[6];  # cano flag
	## $hash{$m[0]}{$key}[4] = $m[1];  # ori
	## $hash{$m[0]}{$key}[5] = $m[7];  # mismatches
			$cano = $hash{$name}{$key}[3];
			$mis = $hash{$name}{$key}[5];
			$term = $hash{$name}{$key}[6];
			
			print $name,"\t", $hash{$name}{$key}[4],"\t",$t[0],"\t", $t[1], "\t255\t",$t[2], "\t",$cano,"\t",$mis,"\t1\t",$hash{$name}{$key}[1],"\t",$hash{$name}{$key}[2],"\t",$term, "\n";
		}
	}
}
