#!/usr/bin/perl 
#
#
#got junctions from temp SAM and present formal SAM
#
# presentJunc_us.pl PJ_canoflag  junctions_score Gapped.sam_4 $bwt.fa temp_file.sam"
#
#
# modified for UnSplicer Jan 2013, Paul Burns


open($in,"<",shift @ARGV); #cano flag

while(<$in>){
	chomp;
	@m = split(/\s+/);
	$t = "$m[0]:$m[1]:$m[2]";
	$cano{$t} = $m[3];
	if($m[3] == 0){
		$N_non++;
	}
	if($m[4] < 0.6){
		$N_low++;
	}

	$N_all++;
}



open($in,"<",shift @ARGV); #junction reference

while(<$in>){
	chomp;
	@m = split(/\t/);
	$t = "$m[0]:$m[1]:$m[2]";
	if($ref{$t} eq ""){
		$ref{$t} = $m[$#m];
	}
	else{
		$ref{$t} = $ref{$t} < $m[$#m]? $m[$#m] : $ref{$t};
	}
}

$gap = shift @ARGV;   # Gapped.sam_4
open($in,"<",$gap);

while(<$in>){
	$lll = $_;
	@m = split(/\t/);
	if($m[$#m] eq "pos=NULL"){
		my @tt = split(/:/,$m[$#m-1]);
		if($tt[2] < 0.1){
			next;
		}
	}
	@k = split(/M|N/,$m[5]);
	$s = $m[3];## need change after gapped reconpile
	for $i (1 .. ($#k)/2){
		$s+=$k[$i*2-2];
		$e = $s + $k[$i*2-1];
		$t = "$m[2]:$s:$e";
		$hash{$t}++;
		$s+=$k[$i*2-1];
	}
}

foreach $key (keys %hash){
	@s = split(/:/,$key);
	push @{$junc_ori{$s[0]}},[$s[1]-1,$s[2]];
}

$chr = "";
$CHR_TEMP = "";
open($in,"<",shift@ARGV);#REF MAY 25
while(<$in>){
	chomp;
	if(substr($_,0,1) eq ">"){
		if($CHR_TEMP ne ""){
			$hash_ori{$chr} = $CHR_TEMP;
			$CHR_TEMP = "";
		}
		Jingyi();
		@c = split(/\s+/,$_); #in case of blank in chr line;
		$chr = substr($c[0],1);
		next;
	}
	$CHR_TEMP .= $_;
}
if($CHR_TEMP ne ""){
	$hash_ori{$chr} = $CHR_TEMP;
	$CHR_TEMP = "";
}
Jingyi();


sub Jingyi{
	my $temp = $chr;
	if($temp ne ""){
		for($i = 0; $i < scalar @{$junc_ori{$temp}}; $i++){
			$f = substr($hash_ori{$temp}, $junc_ori{$temp}[$i][0], 2);
			$e = substr($hash_ori{$temp}, $junc_ori{$temp}[$i][1]-3 , 2);
			$f =~ tr/a-z/A-Z/;
			$e =~ tr/a-z/A-Z/;
			if($f eq "GT" && $e eq "AG" || $f eq "GC" && $e eq "AG" || $f eq "AT"&& $e eq "AC"){
				$flag = "+";
			}
			elsif($f eq "CT" && $e eq "AC" || $f eq "CT"&& $e eq "GC" || $f eq "GT"&& $e eq "AT"){
				$flag = "-";
			}
			else{$flag = "+";}## how to label non-canonical
			my $start = $junc_ori{$temp}[$i][0]+1;
			my $kk = "$temp:$start:$junc_ori{$temp}[$i][1]";
			$ORI{$kk} = $flag;

		}
		delete $hash_ori{$temp};
	}
}

open($in,"<",$gap);      # Gapped.sam_4
open($o1,">GapAli.sam");
open($o2,">GapAli.junc");
$name_temp = "";
@all = ();
#open(dpos,">Gapped.pos");

while(<$in>){
	chomp;
	$lll = $_;
	@m = split(/\t/);
	$name = substr($m[0],0,-2);

	if($name ne $name_temp){
		action();
		@all = ();
		$name_temp = $name;
	}
	push @all, $lll;
}
action();


sub action{
	%flag=();
	%F=();

	my %local_ori = ();
	for($i=0; $i<scalar @all;$i++){
		my @m = split(/\t/,$all[$i]);
		my @k = split(/M|N/,$m[5]);
		$s = $m[3];
		for $ii (1 .. ($#k)/2){                  
			$s+=$k[$ii*2-2];                                         
			$e = $s + $k[$ii*2-1];                                                   
			$t = "$m[2]:$s:$e";
			$local_ori{$i} = $ORI{$t}; 

			$s+=$k[$ii*2-1];
		}
		my @posi = split(/=|:/,$m[$#m-1]);
##print substr($m[0],0,-2), "\t$posi[0]\t$posi[1]\n";
		$NAME_HASH{substr($m[0],0,-2)}{$posi[1]} = 1;
		print $o1 SAM_FLAG($all[$i]),"\tXS:A:$local_ori{$i}\n";
	}
}

foreach $key (keys %FINAL_HASH){
	@j = split(/:/,$key);
	print $o2 "$j[0]\t$j[1]\t$j[2]\t$cano{$key}\t$FINAL_HASH{$key}\t$ref{$key}\n";
}


open(FULL,"<",shift@ARGV);   ## temp_file.sam
open(F,">FULL.sam");
#open(dpos_temp,">temp_file.pos");
while(<FULL>){
	my @m = split(/\s+/);
	#print dpos_temp substr($m[0],0,-2),"\t$m[3]\n";
	if($NAME_HASH{substr($m[0],0,-2)}{$m[3]} == 1){
		print F $_;
	}
}




sub SAM_FLAG{
	my $SUM = 1;
	my $SUM_2 = 0;
	my $L = @_[0];
	my @m = split(/\s+/,$L);
	my @k = split(/M|N/,$m[5]);
	my $s = $m[3];
	for $i (1 .. ($#k)/2){
		$s+=$k[$i*2-2];
		$e = $s + $k[$i*2-1];
		$t = "$m[2]:$s:$e";
		$FINAL_HASH{$t}++;
		if(exists $ALL_MIS{$t}){
			if($ALL_MIS{$t} > $m[4]){
				$ALL_MIS{$t} = $m[4];
			}
		}
		else{
			$ALL_MIS{$t} = $m[4];
		}
		$s+=$k[$i*2-1];
	}
	$m[4] = 255;

	my @pos = split(/=/,$m[$#m-1]);
	my $flag = substr($m[0],-1,1);
	if($flag == 1){
		$SUM_2 += 4;
	}
	else{
		$SUM_2 += 8;
	}
	if($m[1] == 0){
		if($pos[1] eq "NULL"){
			$SUM += 8;
		}
		else{
			$SUM += 2;
			$SUM_2 += 2;
		}
	}
	else{
		if($pos[1] eq "NULL"){
			$SUM += 8;
		}
		else{
			$SUM += 2;
			$SUM_2 += 1;
		}
	}
	if($pos[1] eq "NULL" || $pos[0] eq "tag"){
		$m[6] = "*";
		$m[7] = "0";
		$m[8] = "0";
	}
	else{
		my @k = split(/:/,$pos[0]);
		my $p = int(-($k[2]));
		$m[6] = "=";
		$m[7] = "$pos[1]";
		$m[8] = "$p";
	}
	$m[1] = $SUM_2*16 + $SUM;
	
	my @mout = ();
	
	for ($jj=0; $jj<11; ++$jj) {
		push @mout, $m[$jj];
	}
	push @mout, $m[$#m];
	## $m[$#m]="";
	## $#m = $#m - 1;
	return join("\t",@mout);
}	




