#!/usr/bin/perl
#
#
#

use Getopt::Long;
use POSIX;
use FindBin qw($Bin);

##getopt('co', \%opts);
my $Usage = "svmPredTest.pl\nUsage:\n
-p    gene predictions (.gff file)
-s    DNA sequence
-md   model directory
\n\n";

if ( $#ARGV < 1 ) { print $Usage; exit 1; }

my $cwd = getcwd;
my $infile;
my $suffix;
my $outfile;

## get input args
my $result = GetOptions
(
  'p=s'   => \$gff_ref,
  's=s'   => \$dna,
  'md=s'   => \$model_dir,
);

print "\n";
print "Reference:      $gff_ref\n";
print "DNA sequence:   $dna\n";
print "Model dir:      $model_dir\n";


my @log_gamma = (-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0, 1);
#my @log_gamma = (-10, -9, -8, -7, -6, -5, -4, -3, -2, -1, 0);
#my @log_c = (0, 1, 2, 3, 4, 5, 6, 7, 8, 9, 10);

my $junctions = "../feat_test_set.scaled";
my $orig_final = "../junctions_test_set";
my $gap_score_1 = "$Bin/gapScore -no_seq -clean -off1 -1 -off2 -1 -metrics $gff_ref -scr ";
my $gap_score_2 = " $model_dir $dna score";

for ($ig=0; $ig<scalar(@log_gamma); ++$ig)
{
	$gamma = exp( $log_gamma[$ig] );
	
	#for ($ic=0; $ic<scalar(@log_c); ++$ic)
	for ($ic=0; $ic<7; ++$ic)
	{
		## make predictions
		$mod = "mod_" . "$ig" . "_$ic" . ".model";
		$pred_out = "pred_out_" . "$ig" . "_$ic";
		$cmd = "$Bin/svm-predict  -b 1 $junctions $mod $pred_out";
		print "$cmd\n";
		system( $cmd );
		# remove first line
		$cmd = "cut -f3 -d' ' $pred_out | tail -n 10000 > $pred_out" . "c";
		system( $cmd );
		system("rm $pred_out");
		
		## score the predictions against reference
		$final = "final_" . "$pred_out";
		$cmd = "paste $orig_final $pred_out" . "c" . " > $final";
		print "$cmd\n";
		system( $cmd );
		
		$cmd = "$gap_score_1" . "$final" . "$gap_score_2";
		print "$cmd\n";
		system( $cmd );
		
		## save metrics in special file
		$cmd = "mv metrics.txt metrics" . "_$ig" . "_$ic";
		print "$cmd\n";
		system( $cmd );
	}
	
}

## summarize performance
system("grep 'correct intron' metr* |cut -f2 -d'=' > perf.txt");
system("grep 'correct intron' metr* |cut -c9-100|cut -f1 -d':'|cut -f1 -d'_' > igam");
system("grep 'correct intron' metr* |cut -c9-100|cut -f1 -d':'|cut -f2 -d'_' > ic");
