
#pragma once


// gene types
enum { SINGLE_ISOFORM = 0, MULTIPLE_ISOFORM, ALL_ISOFORMS };

// exon types
enum { EXON_TYPE_SINGLE, EXON_TYPE_INITIAL, EXON_TYPE_INTERNAL, EXON_TYPE_TERMINAL };

// feature types
enum { FEATURE_INTERGENIC, FEATURE_INTRON, FEATURE_CDS,
       FEATURE_EXON, FEATURE_EXON_INI, FEATURE_EXON_INT, FEATURE_EXON_TER,
       FEATURE_START, FEATURE_STOP, FEATURE_DON, FEATURE_ACC };

// intron type (types given by Tophat)
enum { INTRON_GT_AG = 0, INTRON_GC_AG, INTRON_AT_AC, INTRON_BAD };

// true intron types
enum { _INTRON_CDS_FR_0, _INTRON_CDS_FR_1, _INTRON_CDS_FR_2, _INTRON_UTR };

// intron false positive types (one value for left end, another value for right end)
enum { _INTRON_FP_TRUE = -1, _INTRON_FP_CDS_FR_0, _INTRON_FP_CDS_FR_1, _INTRON_FP_CDS_FR_2, _INTRON_FP_UTR, _INTRON_FP_INTRON, _INTRON_FP_INTERG, _INTRON_FP_CDS_WRONG_STRAND };

//enum { EXON_OVERALL = 0, EXON_TRANSCRIPT, EXON_PEPTIDE, EXON_ORTHO, EXON_VISTA };
//enum { GENE_OVERALL_STARS = 0, GENE_OVERALL_CLASS, GENE_TRANSCRIPT, GENE_PEPTIDE, GENE_ORTHO, GENE_VISTA };

enum { _MULTI_PART = 0, _MULTI_BEG, _MULTI_ALN_L, _MULTI_GAP, _MULTI_ALN_R, _MULTI_MIS_L, _MULTI_MIS_R, _MULTI_CANO, _MULTI_ORI };
