
#pragma once

#include <string>
#include <vector>
#include <map>

using namespace std;

struct num_info{
	int count;
	double entro;
};

class point_value{
	public:
		double ori,splice, cod;
};

typedef struct tagIntronScores {
	double coding;
	double spliceDon, spliceAcc;
	double length;
	int flag;
	double covDiffLeft, covDiffRight;
	double depthScore;
	int minMapLen;
	double entropy;
	double invNumCand;
	int mismatches;
	int iframeErr;
	int istrandErr;
	//int igenicState;
	int train;
	double extScore;
} intronScores;

typedef struct tagIntronSample {
	intronScores is;
	string chr;
	int start, end;
} intronSample;

class intronInfo{
	public:
		int count;
		string ori;
		//double entropy;
		//int min_length;
		//interval tron;
		int jcnType;
		intronScores is;
		vector<double> score;	//splicing score	intron_size	 cov	mapping_on mapping_eitherside	solid_fraction lowest_mismatch
		double final_score;
		int stable_partition; //1 or 0 if selected as initial training; -1 if not selected;
		int dynamic_partition; // 1 or 0; if stable_partition >= 0, dynamic should be -1;
};


struct interval{
	int start, end; // [start, end]
	int ori;
	interval(int  s, int  e) : start(s), end(e) {}
};


typedef struct tagSiteScore {
	double score_f0, score_f1, score_f2, score_fn;		// flanking sequence score in 3 frames + noncoding
} siteScore;

typedef struct tagInfoScore {
	vector<int> SAM_info;
	intronInfo score_info;
} sInfoScore;

class potJunc{
	public:
		string SAM;
		map<int,vector<sInfoScore> > blocks;
		//map<int,vector<vector<int> > >SAM_info;// key is part of segment
		//map<int,vector<vector<double> > > score_info;
};

