
#include <string>
#include <limits>

class cOptions
{
public:
	cOptions()
	{
		m_bVerbose = false;
		m_bClean = false;
		m_bMultiFile = false;
		m_bScoreFile = false;
		m_bSortBySum = false;

		m_bHeur = false;

		m_bHuman = false;
		m_bGenic = false;
		m_bNonGenic = false;
		
		m_nOff1 = 0;
		m_nOff2 = 0;

		m_bSpliceSites = false;
		m_bFrameShift = false;
		m_bStrand = false;
		m_bCoding = false;

		m_gcBias = 0;
		m_nCodFlank = 81;
		m_nGcStart = 20;

		m_nSegments = 1;
		m_nSegLength = 25;

		m_bGtf = false;

		m_lfDonThresholdHigh = 10.;
		m_lfAccThresholdHigh = 21.;
		m_lfDonThresholdLow = 8.5;
		m_lfAccThresholdLow = 19.5;
	};
	~cOptions() {  };

	bool parseOptions(int argc, const char** argv);

public:
	// just make everything accessible for now

	// options
	bool m_bVerbose;
	bool m_bClean;
	bool m_bMultiFile;
	bool m_bScoreFile;
	bool m_bHuman;
	bool m_bGenic;
	bool m_bNonGenic;
	bool m_bSortBySum;
	bool m_bGtf;
	bool m_bHeur;

	// filtering switches
	bool m_bSpliceSites;
	bool m_bFrameShift;
	bool m_bStrand;
	bool m_bCoding;

	int m_nCodFlank;

	int m_nOff1, m_nOff2;

	int m_nGcStart;
	int m_gcBias;

	int m_nSegments, m_nSegLength;

	double m_lfDonThresholdHigh, m_lfDonThresholdLow;
	double m_lfAccThresholdHigh, m_lfAccThresholdLow;

	std::string m_multiInFile;
	std::string m_seqInFile;
	std::string m_refInFile;

	std::string m_prefix;		// name prefix to attach to seq and GFF names

	// HMM model directory
	std::string m_modInDir;

	// output multi file
	std::string m_multiOutFile;
};
