
#pragma once

#include <algorithm>
#include "feature.h"

class cAlign
{
public:
	cAlign() { m_match.m_nType = _FEATURE_ALIGNMENT; }
	~cAlign() { }

	bool operator<(cAlign aln) const {
		if (m_ibeg == aln.m_ibeg)
			return m_iend < aln.m_iend;
		else return m_ibeg < aln.m_ibeg;
	}
	bool operator>(cAlign aln) const {
		if (m_ibeg == aln.m_ibeg)
			return m_iend > aln.m_iend;
		else return m_ibeg > aln.m_ibeg;
	}
	bool operator==(cAlign aln) const {
		return m_ibeg==aln.m_ibeg && m_iend==aln.m_iend;
	}

	// get
	string getId() const { return m_strId; }
	string getSeq() const { return m_strSeq; }
	int getBeg() const { return m_ibeg; }
	int getEnd() const { return m_iend; }

	// set
	void setId(string& id) { m_strId = id; }
	void setSeq(string& seq) { m_strSeq = seq; }
	void setStrand(char ch) { m_chStrand = ch; m_match.setStrand(ch); }

	void setLimits() {
		sort();
		if (!m_match.empty()) {
			m_ibeg = m_match.m.front().first();
			m_iend = m_match.m.back().second();
		}
		else { m_ibeg = m_iend = -1; }
	}

	void sort(void) { std::sort( m_match.m.begin(), m_match.m.end() ); }
	void clear(void) { m_strId = string(""); m_chStrand='*'; m_match.clear(); }

	void addMatch(int ibeg, int iend) { m_match.add(ibeg, iend, _INTERVAL_UNDEFINED); }
	void getIntrons(vector<cInterval>& vintrons) const;

public:
	string m_strId;
	string m_strSeq;
	char m_chStrand;
	int m_ibeg, m_iend;
	cFeature<cInterval> m_match;
};

void cAlign::getIntrons(vector<cInterval>& vintrons) const
{	// WARNING: exons MUST be sorted!
	vintrons.clear();

	cInterval intron;
	int type = _INTERVAL_INTRON_NF;

	int flag(0);

	for (int i=1; i<m_match.numel(); ++i)
	{
		intron = cInterval( m_match.m[i-1].second()+1, m_match.m[i].first()-1, type );
		if (intron.first()==123868)
			flag = 1;
		vintrons.push_back( intron );
	}
}
