
#pragma once

//#include <gene.h>
#include "geneType.h"

#include <string>
#include <vector>

using std::string;
using std::vector;

class cJunc
{
public:
	cJunc() {
		m_delim = ". \t";
		m_bScoreFmt = false;
		m_introns.clear();
		m_n = 0;
		m_nOffset1 = m_nOffset2 = 0;
		m_bGetUtrStatus = false;
		m_bStrandCol = false;
		m_scoreThresh = 0.0;
		m_nFeat = 0; };
	~cJunc() { m_introns.clear(); };

	bool loadFile(string& fname);
	bool parseDataLine( string& line );

	bool loadScoreFile( string& fname );
	bool parseScoreLine( string& line );

	vector<sIntron> getIntrons(int nContig, string& seqName);
	vector<sIntron> getIntrons(string& seqName);
	void assignContigs();
	bool findName(string &name);

	vector<sIntron> m_introns;
	vector<string> m_chrNames;

	string m_delim;

	int m_nContig;
	string m_seqName;
	string m_refPrefix;

	bool m_bGetUtrStatus;
	bool m_bScoreFmt;

	int m_n;
	int m_nOffset1, m_nOffset2;
	int m_nFeat;

	double m_scoreThresh;

	bool m_bStrandCol;
};
