
#pragma once

#include <sstream>
//#include <iostream>
//#include <fstream>
#include <string>
#include <vector>
#include <limits>
#include <algorithm>
#include <assert.h>
#include <math.h>

using std::vector;
using std::string;

using namespace std;


struct twoInt
{
	int i;
	int n;
	twoInt operator=(twoInt t) { i=t.i; n=t.n; return t; }
};

struct chInt
{
	char ch;
	int n;
	chInt operator=(chInt t) { ch=t.ch; n=t.n; return t; }
};

struct DoubleXY
{
	double x, y;
	DoubleXY operator=(DoubleXY dxy) { x=dxy.x; y=dxy.y; return dxy; }
};

struct intDouble
{
	int i;
	double y;
	intDouble operator=(intDouble t) { i=t.i; y=t.y; return t; }
};

typedef vector<twoInt> intHist;
typedef vector<DoubleXY> doubleHist;
typedef vector<intDouble> intDoubleHist;
typedef vector<chInt> chHist;

class cHistogram
{
public:

	// ctor/dtor
	cHistogram() { m_bDebug = false; };
	~cHistogram() {  };

	// debug
	bool m_bDebug;

	void loadHist( intHist& hist, string strFile );
	void saveHist( intDoubleHist& hist, string strFile );
	void saveHist( intHist& hist, string strFile );
	void getHist( intHist& hist, vector<int> data );
	//void getHist( chHist& hist, char *pch );
	void calcHistFromFile(string strOutFile, string strInFile, int itype, bool bSmooth3, bool bScale);

	void compressHist( intHist& scaleHist, intHist& rawHist, int iscale );
	void expandHist( intDoubleHist& scaleHist, intDoubleHist& rawHist, int iscale, bool bScale );
	void copyHist( intHist& outHist, intHist& inHist );
	void copyHist( intDoubleHist& outHist, intDoubleHist& inHist );

	void normalizeHist( intDoubleHist& hist );
	void getSmoothHist( intDoubleHist& smoothHist, intHist& rawHist, int imin, int maxLen, int itype, bool bSmooth3, bool bScale, string& outFileBase );
	void getSmoothHist_Mod1( intDoubleHist& smoothHist, intHist& inHist, int maxLen, int itype, bool bSmooth3, bool bScale );
	void interpHist( intDoubleHist& outHist, doubleHist& inHist, int nMin, int nMax );
	void getSmoothingParams( double& K, double& W, intHist& cumHist, double std );
	void smoothHist0( intDoubleHist& outHist, intHist& inHist, int maxLen, double K, double W, string& outFileBase );
	void smoothHist1( intDoubleHist& outHist, intDoubleHist& inHist, int maxLen, double K, double W );
	void smoothHist2( intDoubleHist& outHist, intDoubleHist& inHist, int imin, int maxLen, double K, double W );
	int getNearestPoint( intHist& cumHist, double lfval );
	void getStats( double& mean, double& std, intHist& hist );
	int getCumTotal( intHist& icumhist, intHist& ihist );
	int getCumTotalx( intHist& ihist );
	int getCumTotaly( intHist& ihist );
	double getCumTotalx( doubleHist& dhist );

	void doubleInt2intHst( intHist& ihist, intDoubleHist& dhist );
	void int2intDouble( intDoubleHist& dhist, intHist& ihist );
	void int2double( doubleHist& dhist, intHist& ihist );
	void updateHistogram( intHist& hist, int inew );
	void sortHist( intHist& inHist );
	void sortHist( double& fGlobalMin, double& fGlobalMax, doubleHist& rawHist );
	intDouble getPeakPt( intDoubleHist& hist );

	void getCount( double& yCount, double& xCount, int& nLastSample,
				   double fStart, double fInc, doubleHist& histArray );
	void getBinHist( doubleHist& binHist, doubleHist& rawHist, int nBins, bool bCumulative );
	void getBinHist( doubleHist& binHist, doubleHist& rawHist, double fBinSize, bool bCumulative );
	void getLogBinHist( doubleHist& outHist, doubleHist& rawHist, int nBins, bool bCumulative );
	void calcBinHist( doubleHist& binHist, doubleHist& rawHist, double fGlobalMin, double fBinSize, int nBins, bool bCumulative );
	void Log( doubleHist& outHist, doubleHist& inHist );
	void Exp( doubleHist& outHist, doubleHist& inHist );

	string printHistogram(string strHeader, intHist& hist, string strSep);
	string printHistogram(string strHeader, doubleHist& hist, double fBinSize, bool bCumulative);

	void calcSlope( double& slope, doubleHist& dhist, double xThresh, double yThresh );
	void lsFit( double x[2], vector<double>& px, vector<double>& py );
	double sumVect( vector<double>& x );
	double innerProd( vector<double>& x, vector<double>& y );

};

