//**************************************************
// file:    matrix.h
// project: ehmm
//**************************************************

#ifndef __MATRIX_H__
#define __MATRIX_H__


// #define NDEBUG
#include <assert.h>
#include <ctype.h>
#include <vector>
#include <string>
#include "sseq.h"

using std::vector;
using std::string;

//--------------------------------------------------
class cMatrixMod
{
public:

	bool RevFromDir( double* dir, double** rev , int order );
	bool AbsToFirst( double* abs, double** rel, int order );
	bool HiToLo( double* hi, double** lo, int hiOrder );
	void Log( double* ptr , int size );
	void Exp( double* ptr , int size );
	bool AllocArray( double** data, int size );

	// taken from mkmarkov.c
	void SetAlphabet( char* ptr );
	int Calc( double* mat, const char* buf, char* alphabet, int order, int fr, int fsize, bool bAddCompl );
	int Calc0( double* mat, const char* buf, char* alphabet, int order, int fsize, bool bAddCompl );
	int Calc( double* mat, char* buf, char* alphabet, int order, int fr, int fsize, bool bAddCompl );
	void Calc( double *pMat, vector<string>& dataVect, int order, int flankLeft, int flankRight );
	void Calc( double *pMat, vector<string>& dataVect, int order, int len, int flankLeft, int flankRight );
	char* MakeIndex( int k, int order, char* ptr );

private:

	void DoRevFromDir( double* dir, double* rev , int order );
	void DoHiToLo( double* hi, double* lo, int hiOrder );
	void DoAbsToFirst( double* abs, double* rel, int order );

};
//--------------------------------------------------

#endif // __MATRIX_H__

