//**************************************************
// file:    report.cpp
// project: probuild
//          alex lomsadze
//**************************************************

#include "report.h"

//--------------------------------------------------
void Report::Submit( const string& key, const string& comment, const string& value )
{
	result[key].first = comment;
	result[key].second = value;
};
//--------------------------------------------------
void Report::Submit( const string& key, const string& comment, int i )
{
	ostringstream out;
	out << i;

	result[key].first = comment;
	result[key].second = out.str();
};
//--------------------------------------------------
bool Report::CheckReport( list<string>& request )
{
	for( list<string>::iterator i = request.begin(); i != request.end(); ++i )
	{
		if ( (*i).empty() )
		{ cerr << "error: no value in request" << endl; return false; }

		if ( result.find( (*i) ) == result.end() )
		{ cerr << "error: no entry to report, " << (*i) << endl; return false; }

		if ( result[*i].second.empty() )
		{ cerr << "error: no value to report, " << (*i) << endl; return false; };
	}
	return true;
};
//--------------------------------------------------
void Report::PrintAll( const string& name )
{
	map<string,pair<string,string> >::iterator itr;

	if ( name.empty() )
	{
		for( itr = result.begin(); itr != result.end(); ++itr )
			cout << (*itr).second.first << (*itr).second.second << endl;
	}
	else
	{
		ofstream F;

		if (mode)
			F.open( name.c_str(),  ios_base::out | ios_base::app );
		else 
			F.open( name.c_str());
		for( itr = result.begin(); itr != result.end(); ++itr )
			F << (*itr).second.first << (*itr).second.second << endl;
		F.close();
	}
};
//--------------------------------------------------
void Report::PrintSelected( list<string>& request, const string& name )
{
	list<string>::iterator itr;

	if ( name.empty() )
	{
		for( itr = request.begin(); itr != request.end(); ++itr )
			cout << result[*itr].first << result[*itr].second << endl;
	}
	else
	{
		ofstream F;

		if (mode)
			F.open( name.c_str(),  ios_base::out | ios_base::app );
		else 
			F.open( name.c_str());
		for( itr = request.begin(); itr != request.end(); ++itr )
			F << result[*itr].first << result[*itr].second << endl;
		F.close();
	}
};
//--------------------------------------------------
bool Report::PrintOut( const string& name, bool app )
{
	mode = app;

	if ( request.empty() )
		PrintAll( name );
	else
	{
		if ( !CheckReport( request ) )
			return false;
		PrintSelected( request, name );
	}

	return true;
};
//--------------------------------------------------
bool Report::PrintOut( const string& name )
{
	mode = false;

	if ( request.empty() )
		PrintAll( name );
	else
	{
		if ( !CheckReport( request ) )
			return false;
		PrintSelected( request, name );
	}

	return true;
};
//--------------------------------------------------
